// купюроприемник IC A7 V7
const int moneyPin1=2;
// монетоприемник CH-926
const int moneyPin2=3;
// хоппер suzo mk2
const int moneyPin3=21;
const int powerHopper=8;
int nominal_kup=10;
int nominal_hop=10;
// кнопка
const int pinButton=8;
boolean lastButton=HIGH;
boolean currentButton=HIGH;

int pulse1=0;
int pulse2=0;
int pulse3=0;

unsigned long timeAllPulse1=2000; // макс. время приема купюры
unsigned long timeAllPulse2=500; // макс. время приема монеты
unsigned long timeCount1=0;
unsigned long timeCount2=0;

int sum=0;
// дисплей WH1602
#include <LiquidCrystalRus.h>
LiquidCrystalRus lcd(12,11,7,6,5,4);




void setup()
{
  Serial.begin(9600);  
  //
  pinMode(moneyPin1,INPUT);
  pinMode(moneyPin2,INPUT);
  pinMode(moneyPin3,INPUT);
  pinMode(pinButton,INPUT);
 
  Serial.println("coin ready");
  lcd.begin(16,2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Внесите деньги");
  delay(1000);
  attachInterrupt(0,count_pulse1,FALLING);
  attachInterrupt(1,count_pulse2,FALLING);
}

void loop()
{
  // нажатие кнопки
  currentButton=debounce(lastButton);
  if(lastButton==HIGH && currentButton==LOW)
    {
    doForKey();
    }
  lastButton=currentButton;
  // прошло максимальное время приема монеты?
  if(pulse2>0 && (millis()-timeCount2)>timeAllPulse2) 
    {
     sum=nominal_kup; 
     pulse2=0;
     lcd.clear();
     lcd.setCursor(0,0);lcd.print("Баланс");
     lcd.setCursor(0,1);lcd.print(sum);
    }
  // прошло максимальное время приема купюры?
  if(pulse1>0 && (millis()-timeCount1)>timeAllPulse1) 
    {
    sum+=pulse1*10;
    pulse1=0;  
    lcd.clear();
    lcd.setCursor(0,0);lcd.print("Баланс");
    lcd.setCursor(0,1);lcd.print(sum);
    }
}

// обработка прерывания монетоприемника - получить кол-во импульсов
//  
void count_pulse2()
  {
  detachInterrupt(1);
  pulse2++;
  if(pulse2==1)
      timeCount2=millis();
  attachInterrupt(1,count_pulse2,FALLING);
  }
// обработка прерывания купюроприемника - получить кол-во импульсов
//  
void count_pulse1()
  {
  detachInterrupt(0);
  //detachInterrupt(1);
  pulse1++;
  if(pulse1==1)
       timeCount1=millis();
  attachInterrupt(0,count_pulse1,FALLING);
  }
// обработка прерывания хоппера  
void count_pulse3()
  {
  detachInterrupt(2);
  pulse3++;
  attachInterrupt(2,count_pulse3,FALLING);
  }
// обработка нажатия кнопки
void doForKey() {
   if(sum==0)
     return;
   detachInterrupt(0);
   detachInterrupt(1);
   attachInterrupt(2,count_pulse3,FALLING);
   pulse3=0;
   lcd.clear();
   lcd.setCursor(0,0);lcd.print("Размен");
   digitalWrite(powerHopper,HIGH);
   while(pulse3<=sum/nominal_hop)
      {
      delay(50);
      }
   digitalWrite(powerHopper,LOW);
   detachInterrupt(2);
   lcd.clear();
   lcd.setCursor(0,0);lcd.print("Размен");
   lcd.setCursor(0,1);lcd.print("произведен");
   delay(3000);
   lcd.clear();
   lcd.setCursor(0,0);
   lcd.print("Внесите деньги");
   attachInterrupt(0,count_pulse1,FALLING);
   attachInterrupt(1,count_pulse2,FALLING);
   sum=0;
 }
// проверка на дребазг
boolean debounce(boolean last)
  {
  boolean current=digitalRead(pinButton);
  if(last!=current)
    {
    delay(5);
    current=digitalRead(pinButton);
    }  
  return current;
  }
